package cz.mendelu.dnaAnalyser.sequence.data;

import cz.mendelu.dnaAnalyser.utils.controller.GetMapping;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.util.UUID;

@RestController
@Api(tags = "api/sequence/{id}/data")
@RequestMapping("api/sequence")
public class SequenceDataController {
    @Autowired
    private BufferSequenceDataService sequenceService;

    @GetMapping(
            path = "/{id}/data",
            produces = MediaType.TEXT_PLAIN_VALUE)
    @ResponseStatus(HttpStatus.OK)
    @PreAuthorize("isAuthenticated()")
    @ApiOperation("Get sequence data")
    public String sequenceData(
            @PathVariable UUID id,
            @RequestParam(name = "pos", defaultValue = "0") int pos,
            @RequestParam(name = "len", defaultValue = "100") int len
    ) {
        SequenceData buffer = sequenceService.findSequenceBuffer(id);
        return buffer.toString(pos, len);
    }
}
