package cz.mendelu.dnaAnalyser.user;

import cz.mendelu.dnaAnalyser.sequence.Sequence;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.Optional;
import java.util.UUID;

/**
 * Created by stephan on 20.03.16.
 */
@Repository
public interface UserRepository extends CrudRepository<User, UUID> {

    Optional<User> findByUsername(String login);

    @Query("select u from User u where u.id = ?#{principal.id}")
    User findCurrentUser();

    /**
     * This method found default sequence for new user.
     *
     * Oproti metoda na SequenceRepository ignoruje vlastníka sekvence.
     * Proto se musí použít pouze pro hledání výchozích uživatelských sekvencí.
     *
     * TODO Dodělat na to samostatnou service s vlastním repositářem, pokud se ukáže potřebaa iportovat i další data.
     * @param id
     * @return
     */
    @Query("select s from Sequence as s where s.id = :id")
    Optional<Sequence> findDefaultSequenceById(@Param("id") UUID id);

}
