package cz.mendelu.dnaAnalyser.utils.controller;

import com.fasterxml.jackson.annotation.JsonInclude;
import cz.mendelu.dnaAnalyser.batch.Batch;
import lombok.Data;

import static com.fasterxml.jackson.annotation.JsonInclude.Include.NON_NULL;

@Data
@JsonInclude(NON_NULL)
public class Response<R>  {

    public static <E> Response<E> response(E payload) {
        Response<E> response = new Response<>();
        response.payload = payload;
        return response;
    }

    public Response() {}

    private R payload;

    private Batch batch;

    private String downloadToken;

}
