package cz.mendelu.dnaAnalyser.analyse.quadruplex.api

import cz.mendelu.dnaAnalyser.utils.api.ApiRestTemplate
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import org.springframework.test.context.ActiveProfiles
import spock.lang.Ignore
import spock.lang.Specification

import static org.springframework.boot.test.context.SpringBootTest.WebEnvironment.RANDOM_PORT

@SpringBootTest(webEnvironment = RANDOM_PORT)
@ActiveProfiles("test")
class QuadruplexControllerTest extends Specification {

    @Autowired
    ApiRestTemplate api

    def setup() {
        api.testAuthentication('QuadruplexControllerTest')
    }

    @Ignore
    def "GET:/api/quadruplex Quadruplexs"(){
        when:
        def response = api.get("/api/quadruplex}")

        then:
        response.status == 200
    }

    @Ignore
    def "GET:/api/quadruplex/{id} Quadruplex"(){
        setup:
        def id = UUID.randomUUID()

        when:
        def response = api.get("/api/sequence/${id}")

        then:
        response.status == 200

    }

    @Ignore
    def "POST:/api/quadruplex Start quadruplex analyze"(){
        when:
        def response = api.post("/api/quadruplex", null)

        then:
        response.status == 201
    }

    @Ignore
    def "DELETE:/api/quadruplex/{id} delete Quadruplex"(){
        setup:
        def id = UUID.randomUUID()

        when:
        def response = api.delete("/api/quadruplex/${id}")

        then:
        response.status == 204
    }

}
